/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "dma.h"
#include "memorymap.h"
#include "rtc.h"
#include "spi.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

#include <stdio.h>

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MPU_Config(void);
/* USER CODE BEGIN PFP */

void SPI_WriteComm(uint8_t);
void SPI_WriteData(uint8_t);


/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{

  /* USER CODE BEGIN 1 */

  printf("Program start (%s, %s).\n", __TIME__, __DATE__);

  /* USER CODE END 1 */

  /* MPU Configuration--------------------------------------------------------*/
  MPU_Config();

  /* Enable the CPU Cache */

  /* Enable I-Cache---------------------------------------------------------*/
  SCB_EnableICache();

  /* Enable D-Cache---------------------------------------------------------*/
  SCB_EnableDCache();

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_RTC_Init();
  MX_SPI4_Init();
  /* USER CODE BEGIN 2 */

  HAL_GPIO_WritePin(PWM_DISPLAY_LIGHT_GPIO_Port, PWM_DISPLAY_LIGHT_Pin, GPIO_PIN_SET);
  HAL_GPIO_WritePin(RST_DISPLAY_GPIO_Port, RST_DISPLAY_Pin, GPIO_PIN_SET);

  SPI_WriteComm(0x11);
  HAL_Delay(120);

  SPI_WriteComm(0xFF);
  SPI_WriteData(0x77);
  SPI_WriteData(0x01);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);
  SPI_WriteData(0x10);


  SPI_WriteComm(0xC0);
  SPI_WriteData(0x4F);
  SPI_WriteData(0x00);


  SPI_WriteComm(0xC1);
  SPI_WriteData(0x07);
  SPI_WriteData(0x02);


  SPI_WriteComm(0xC2);
  SPI_WriteData(0x31);
  SPI_WriteData(0x05);

  SPI_WriteComm(0xC3);
  SPI_WriteData(0x80);
  SPI_WriteData(0x02);
  SPI_WriteData(0x07);

  SPI_WriteComm(0xCC);
  SPI_WriteData(0x10);

  SPI_WriteComm(0xB0);
  SPI_WriteData(0x00);
  SPI_WriteData(0x0A);
  SPI_WriteData(0x11);
  SPI_WriteData(0x0C);
  SPI_WriteData(0x10);
  SPI_WriteData(0x05);
  SPI_WriteData(0x00);
  SPI_WriteData(0x08);
  SPI_WriteData(0x08);
  SPI_WriteData(0x1F);
  SPI_WriteData(0x07);
  SPI_WriteData(0x13);
  SPI_WriteData(0x10);
  SPI_WriteData(0xA9);
  SPI_WriteData(0x30);
  SPI_WriteData(0x18);
  SPI_WriteComm(0xB1);
  SPI_WriteData(0x00);
  SPI_WriteData(0x0B);
  SPI_WriteData(0x11);
  SPI_WriteData(0x0D);
  SPI_WriteData(0x0F);
  SPI_WriteData(0x05);
  SPI_WriteData(0x02);
  SPI_WriteData(0x07);
  SPI_WriteData(0x06);
  SPI_WriteData(0x20);
  SPI_WriteData(0x05);
  SPI_WriteData(0x15);
  SPI_WriteData(0x13);
  SPI_WriteData(0xA9);
  SPI_WriteData(0x30);
  SPI_WriteData(0x18);
  SPI_WriteComm(0xFF);
  SPI_WriteData(0x77);
  SPI_WriteData(0x01);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);
  SPI_WriteData(0x11);


  SPI_WriteComm(0xB0);
  SPI_WriteData(0x53);
  SPI_WriteComm(0xB1);
  SPI_WriteData(0x60);

  SPI_WriteComm(0xB2);
  SPI_WriteData(0x07);

  SPI_WriteComm(0xB3);
  SPI_WriteData(0x80);

  SPI_WriteComm(0xB5);
  SPI_WriteData(0x49);

  SPI_WriteComm(0xB7);
  SPI_WriteData(0x85);

  SPI_WriteComm(0xB8);
  SPI_WriteData(0x21);

  SPI_WriteComm(0xC1);
  SPI_WriteData(0x78);

  SPI_WriteComm(0xC2);
  SPI_WriteData(0x78);
  HAL_Delay(100);

  SPI_WriteComm(0xE0);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);
  SPI_WriteData(0x02);

  SPI_WriteComm(0xE1);
  SPI_WriteData(0x03);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);
  SPI_WriteData(0x02);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);
  SPI_WriteData(0x33);
  SPI_WriteData(0x33);
  SPI_WriteComm(0xE2);
  SPI_WriteData(0x22);
  SPI_WriteData(0x22);
  SPI_WriteData(0x33);
  SPI_WriteData(0x33);
  SPI_WriteData(0x88);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);
  SPI_WriteData(0x87);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);


  SPI_WriteComm(0xE3);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);
  SPI_WriteData(0x22);
  SPI_WriteData(0x22);

  SPI_WriteComm(0xE4);
  SPI_WriteData(0x44);
  SPI_WriteData(0x44);

  SPI_WriteComm(0xE5);
  SPI_WriteData(0x04);
  SPI_WriteData(0x84);
  SPI_WriteData(0xA0);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x06);
  SPI_WriteData(0x86);
  SPI_WriteData(0xA0);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x08);
  SPI_WriteData(0x88);
  SPI_WriteData(0xA0);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x0A);
  SPI_WriteData(0x8A);
  SPI_WriteData(0xA0);
  SPI_WriteData(0xA0);

  SPI_WriteComm(0xE6);
  SPI_WriteData(0x00);
  SPI_WriteData(0x00);
  SPI_WriteData(0x22);
  SPI_WriteData(0x22);

  SPI_WriteComm(0xE7);
  SPI_WriteData(0x44);
  SPI_WriteData(0x44);

  SPI_WriteComm(0xE8);
  SPI_WriteData(0x03);
  SPI_WriteData(0x83);
  SPI_WriteData(0xA0);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x05);
  SPI_WriteData(0x85);
  SPI_WriteData(0xA0);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x07);
  SPI_WriteData(0x87);
  SPI_WriteData(0xA0);
  SPI_WriteData(0xA0);
  SPI_WriteData(0x09);
  SPI_WriteData(0x89);
  SPI_WriteData(0xA0);
  SPI_WriteData(0xA0);

  SPI_WriteComm(0xEB);
  SPI_WriteData(0x00);
  SPI_WriteData(0x01);
  SPI_WriteData(0xE4);
  SPI_WriteData(0xE4);
  SPI_WriteData(0x88);
  SPI_WriteData(0x00);
  SPI_WriteData(0x40);

  SPI_WriteComm(0xEC);
  SPI_WriteData(0x3C);
  SPI_WriteData(0x01);

  SPI_WriteComm(0xED);
  SPI_WriteData(0xAB);
  SPI_WriteData(0x89);
  SPI_WriteData(0x76);
  SPI_WriteData(0x54);
  SPI_WriteData(0x02);
  SPI_WriteData(0xFF);
  SPI_WriteData(0xFF);
  SPI_WriteData(0xFF);
  SPI_WriteData(0xFF);
  SPI_WriteData(0xFF);
  SPI_WriteData(0xFF);
  SPI_WriteData(0x20);
  SPI_WriteData(0x45);
  SPI_WriteData(0x67);
  SPI_WriteData(0x98);
  SPI_WriteData(0xBA);


  SPI_WriteComm(0x3A);
  SPI_WriteData(0x66);

  SPI_WriteComm(0x36);
  SPI_WriteData(0x00);

  HAL_Delay(100);
  SPI_WriteComm(0x29);


  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Supply configuration update enable
  */
  HAL_PWREx_ConfigSupply(PWR_LDO_SUPPLY);

  /** Configure the main internal regulator output voltage
  */
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE2);

  while(!__HAL_PWR_GET_FLAG(PWR_FLAG_VOSRDY)) {}

  /** Configure LSE Drive Capability
  */
  HAL_PWR_EnableBkUpAccess();
  __HAL_RCC_LSEDRIVE_CONFIG(RCC_LSEDRIVE_LOW);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE|RCC_OSCILLATORTYPE_LSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.LSEState = RCC_LSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 5;
  RCC_OscInitStruct.PLL.PLLN = 40;
  RCC_OscInitStruct.PLL.PLLP = 2;
  RCC_OscInitStruct.PLL.PLLQ = 2;
  RCC_OscInitStruct.PLL.PLLR = 2;
  RCC_OscInitStruct.PLL.PLLRGE = RCC_PLL1VCIRANGE_2;
  RCC_OscInitStruct.PLL.PLLVCOSEL = RCC_PLL1VCOWIDE;
  RCC_OscInitStruct.PLL.PLLFRACN = 0;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2
                              |RCC_CLOCKTYPE_D3PCLK1|RCC_CLOCKTYPE_D1PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.SYSCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_HCLK_DIV1;
  RCC_ClkInitStruct.APB3CLKDivider = RCC_APB3_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_APB1_DIV1;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_APB2_DIV1;
  RCC_ClkInitStruct.APB4CLKDivider = RCC_APB4_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_1) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

void SPI_Transmit(uint8_t cmd_data_toSend, uint8_t isCmd)
{
	uint16_t data[1];

	data[0] = (uint16_t)cmd_data_toSend | ((uint16_t)isCmd << (sizeof(uint16_t) * 8));

	HAL_SPI_Transmit(&hspi4, (const uint8_t*)data, 1, 1000);
}

void SPI_WriteComm(uint8_t cmdToSend)
{
	SPI_Transmit(cmdToSend, 0);
}

//------------------------------------------------------------------------------

void SPI_WriteData(uint8_t dataToSend)
{
	SPI_Transmit(dataToSend, 1);
}

//------------------------------------------------------------------------------

/* USER CODE END 4 */

 /* MPU Configuration */

void MPU_Config(void)
{
  MPU_Region_InitTypeDef MPU_InitStruct = {0};

  /* Disables the MPU */
  HAL_MPU_Disable();

  /** Initializes and configures the Region and the memory to be protected
  */
  MPU_InitStruct.Enable = MPU_REGION_ENABLE;
  MPU_InitStruct.Number = MPU_REGION_NUMBER0;
  MPU_InitStruct.BaseAddress = 0x0;
  MPU_InitStruct.Size = MPU_REGION_SIZE_4GB;
  MPU_InitStruct.SubRegionDisable = 0x87;
  MPU_InitStruct.TypeExtField = MPU_TEX_LEVEL0;
  MPU_InitStruct.AccessPermission = MPU_REGION_NO_ACCESS;
  MPU_InitStruct.DisableExec = MPU_INSTRUCTION_ACCESS_DISABLE;
  MPU_InitStruct.IsShareable = MPU_ACCESS_SHAREABLE;
  MPU_InitStruct.IsCacheable = MPU_ACCESS_NOT_CACHEABLE;
  MPU_InitStruct.IsBufferable = MPU_ACCESS_NOT_BUFFERABLE;

  HAL_MPU_ConfigRegion(&MPU_InitStruct);
  /* Enables the MPU */
  HAL_MPU_Enable(MPU_PRIVILEGED_DEFAULT);

}

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
